#ifndef _KILIB_MEMORY_H_
#define _KILIB_MEMORY_H_
#include "types.h"
#include "thread.h"
#ifndef __ccdoc__
namespace ki {
#endif



// K͂ƌȂIuWFNg̍őTCY
#define SMALL_MAX 64
// xɊmۂq[vubÑTCY
#define BLOCK_SIZ 4096
// 
struct MemBlock;



//=========================================================================
//@{ @pkg ki.Memory //@}
//@{
//	蓖āE@\
//
//	SUPERTINYIvVtăRpCƁAW
//	mallocfreegȂȂ邽߁AHeapAllocAPI
//	ڌĂяoKvoĂ܂BA{
//	񒼂ɌĂłƁAxBAzƁAoJƁA
//	ĐŒxBŁAnewœIɏK̓
//	mۂ邱ƂɎ𐘂ȒPȃAP[^gƂɂ܂B
//
//	<a href="http://cseng.aw.com/book/0,3828,0201704315,00.html">loki</a>
//	Cuقڂ̂܂܂ȎłB
//@}
//=========================================================================

class MemoryManager : public EzLockable
{
public:

	//@{ 蓖 //@}
	void* Alloc( int siz );

	//@{  //@}
	void DeAlloc( void* ptr, int siz );

private:

	struct FixedSizeMemBlockPool
	{
		void Construct( byte siz );
		void Destruct();
		void*  Alloc();
		void DeAlloc( void* ptr );
		bool isValid();
	private:
		MemBlock* blocks_;
		int       blockNum_;
		int       blockNumReserved_;
		byte      fixedSize_;
		byte      numPerBlock_;
		int       lastA_;
		int       lastDA_;
	};

private:

	MemoryManager();
	~MemoryManager();

private:

	FixedSizeMemBlockPool pools_[ SMALL_MAX ];
	static MemoryManager* pUniqueInstance_;

private:

	friend void APIENTRY Startup();
	friend inline MemoryManager& mem();
	NOCOPY(MemoryManager);
};



//-------------------------------------------------------------------------

//@{ B̃ǗIuWFNgԂ //@}
inline MemoryManager& mem()
	{ return *MemoryManager::pUniqueInstance_; }

//@{ [ߍ //@}
inline void* memzero( void* ptr, int siz )
	{ return memset( ptr, 0, siz ); }



//=========================================================================
//@{
//	WNX
//
//	JavaObject  MFCCObject ݂Ɏgc킯ł͂ȂA
//	PɂhƎ operator new/delete ł
//	Ȃ̂ŕ֗AƂĝ߂̊NXłB
//@}
//=========================================================================

class Object
{
public:

	static void* operator new( size_t siz )
		{ return mem().Alloc( siz ); }

	static void operator delete( void* ptr, size_t siz )
		{ mem().DeAlloc( ptr, siz ); }

protected:

	virtual ~Object()
		{}
};



//=========================================================================

}      // namespace ki
#endif // _KILIB_MEMORY_H_
